Administrator/routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PostController;
use App\Http\Controllers\EventController;
use App\Http\Controllers\ImagesController;
use App\Http\Controllers\WelcomeController;

// Welcome Blade Start up - DONT TOUCH
// Route::get('/', function () {
//     // return view('welcome');
// })->name('welcome');

Route::resource('/', WelcomeController::class);
Route::get('/discussion/{id}', [WelcomeController::class, 'discussion'])->name('discussion');
Route::get('/discussion/post/{post}', [WelcomeController::class, 'discussionPost'])->name('discussion.post');

// Authorized Routes - DONT TOUCH
Auth::routes();

// Dashboard Route - DONT TOUCH
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Auth::routes();

// Dashboard Authorized route - DONT TOUCH
Route::get('/home', 'App\Http\Controllers\HomeController@index')->name('home')->middleware('auth');

// Authorization -> user need to be loged in to access this routes
Route::group(['middleware' => 'auth'], function () {
	// Calendar - DONT TOUCH
	Route::get('/events/recent', [EventController::class, 'recentEventsJson'])->name('events.recent');
    Route::resource('events', EventController::class);

	// Map - DONT TOUCH
	Route::get('map', function () {
		return view('pages.map');
	})->name('map');
	
	// Posts
	Route::resource('/post', PostController::class);

	// Images
	Route::resource('/image', ImagesController::class);
});

// Frameword user manager configuration routes - DONT TOUCH
Route::group(['middleware' => 'auth'], function () {
	Route::resource('user', 'App\Http\Controllers\UserController', ['except' => ['show']]);
	Route::get('profile', ['as' => 'profile.edit', 'uses' => 'App\Http\Controllers\ProfileController@edit']);
	Route::put('profile', ['as' => 'profile.update', 'uses' => 'App\Http\Controllers\ProfileController@update']);
	Route::put('profile/password', ['as' => 'profile.password', 'uses' => 'App\Http\Controllers\ProfileController@password']);
});

Administrator/app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    use HasFactory;

    protected $guarded = [];
}

Administrator/app/Http/Controllers/Api/PostController.php
<?php

namespace App\Http\Controllers\Api;

use App\Models\Post;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Http\Requests\PostRequest;
use App\Http\Resources\PostCollection;

class PostController extends Controller
{
       // api/users
       public function index()
       {
           return new PostCollection(Post::all());
       }
   
       // api/Posts/create
       public function store(PostRequest $request)
       {
           // if (!in_array($request->faculty_id, Faculty::pluck('id')->toArray()))
               // return response()->json(['error' => 'Faculty doesnt exist', 'status' => 400]);
   
   
           if (Post::create($request->validated()))
               return response()->json(['success' => 'success', 'status' => 200]);
       }
}

Administrator/app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Models\Post;
use Illuminate\Http\Request;

class PostController extends Controller
{

    public function index(Post $model)
    {
        return view('pages.posts.index', ['posts' => $model->paginate(15)]);
    }

    public function create()
    {
        //
    }

    public function store(Request $request)
    {
        //
    }

    public function show($id)
    {
        return view('pages.posts.show', ['post' => Post::where('id', $id)->first()]);
    }

    public function edit($id)
    {
        return view('pages.posts.edit', ['post' => Post::where('id', $id)->first()]);
    }

    public function update(Request $request, $id)
    {
        Post::where('id', $id )->update($request->except(['_token', '_method']));

        return back()->withStatus(__('Profile successfully updated.'));
    }

    public function destroy($id)
    {
        Post::where('id', $id)->delete();
        return back()->withStatus(__('Post successfully deleted.'));
    }
}

Administrator/app/Http/Livewire/PostTable.php
<?php

namespace App\Http\Livewire;

use App\Models\Post;
use Illuminate\Support\Str;
use Illuminate\Support\Carbon;
use Illuminate\Database\QueryException;
use Illuminate\Database\Eloquent\Builder;
use PowerComponents\LivewirePowerGrid\Button;
use PowerComponents\LivewirePowerGrid\Column;
use PowerComponents\LivewirePowerGrid\PowerGrid;
use PowerComponents\LivewirePowerGrid\Rules\Rule;
use PowerComponents\LivewirePowerGrid\PowerGridEloquent;
use PowerComponents\LivewirePowerGrid\PowerGridComponent;
use PowerComponents\LivewirePowerGrid\Traits\ActionButton;

final class PostTable extends PowerGridComponent
{
    use ActionButton;

    //Messages informing success/error data is updated.
    public bool $showUpdateMessages = true;

    public function setUp(): void
    {
        // $this->showCheckBox()
        //     ->showPerPage()
        //     ->showSearchInput()
        //     ->showExportOption('download', ['excel', 'csv']);
    }

    public function datasource(): ?Builder
    {
        return Post::query();
    }

    public function relationSearch(): array
    {
        return [];
    }

    public function addColumns()
    {
        return PowerGrid::eloquent()
            ->addColumn('id')
            ->addColumn('title')
            ->addColumn('desc', function (Post $model) {
                return Str::words($model->desc, 1); //Gets the first 'n' words
            })
            ->addColumn('actions', function(Post $model) {
                return view('layouts.actions.action', [
                    'e' => route('post.edit', ['post' => $model->id]),
                    'd' => route('post.destroy', ['post' => $model->id]),
                    'v' => route('post.show', ['post' => $model->id])
                ]);
            });
    }

    public function columns(): array
    {
        return [
            Column::add()
                ->title('ID')
                ->field('id')
                ->sortable(),

            Column::add()
                ->title('Title')
                ->field('title')
                ->sortable(),

            Column::add()
                ->title('Description')
                ->field('desc'),

            Column::add()
                ->title('Actions')
                ->field('actions')
                
        ];
    }

    /*
    |--------------------------------------------------------------------------
    | Actions Method
    |--------------------------------------------------------------------------
    | Enable the method below only if the Routes below are defined in your app.
    |
    */

     /**
     * PowerGrid Post Action Buttons.
     *
     * @return array<int, \PowerComponents\LivewirePowerGrid\Button>
     */

    // public function actions(): array
    // {
    //    return [
    //        Button::add('edit')
    //            ->caption('Edit')
    //            ->class('btn btn-warning btn-link')
    //            ->route('post.edit', ['post' => 'id']),

    //        Button::add('destroy')
    //            ->caption('Delete')
    //            ->class('btn btn-danger btn-link')
    //            ->route('post.destroy', ['post' => 'id'])
    //            ->method('delete')
    //     ];
    // }

    /*
    |--------------------------------------------------------------------------
    | Actions Rules
    |--------------------------------------------------------------------------
    | Enable the method below to configure Rules for your Table and Action Buttons.
    |
    */

     /**
     * PowerGrid Post Action Rules.
     *
     * @return array<int, \PowerComponents\LivewirePowerGrid\Rules\RuleActions>
     */

    /*
    public function actionRules(): array
    {
       return [
           
           //Hide button edit for ID 1
            Rule::button('edit')
                ->when(fn($post) => $post->id === 1)
                ->hide(),
        ];
    }
    */

    /*
    |--------------------------------------------------------------------------
    | Edit Method
    |--------------------------------------------------------------------------
    | Enable the method below to use editOnClick() or toggleable() methods.
    | Data must be validated and treated (see "Update Data" in PowerGrid doc).
    |
    */

     /**
     * PowerGrid Post Update.
     *
     * @param array<string,string> $data
     */

    /*
    public function update(array $data ): bool
    {
       try {
           $updated = Post::query()
                ->update([
                    $data['field'] => $data['value'],
                ]);
       } catch (QueryException $exception) {
           $updated = false;
       }
       return $updated;
    }

    public function updateMessages(string $status = 'error', string $field = '_default_message'): string
    {
        $updateMessages = [
            'success'   => [
                '_default_message' => __('Data has been updated successfully!'),
                //'custom_field'   => __('Custom Field updated successfully!'),
            ],
            'error' => [
                '_default_message' => __('Error updating the data.'),
                //'custom_field'   => __('Error updating custom field.'),
            ]
        ];

        $message = ($updateMessages[$status][$field] ?? $updateMessages[$status]['_default_message']);

        return (is_string($message)) ? $message : 'Error!';
    }
    */
}

Administrator/resources/views/pages/posts/edit.blade.php
@extends('layouts.app', ['activePage' => 'posts', 'titlePage' => __('Posts')])

@section('content')
<div class="content">
  <div class="container-fluid">
    <div class="row">
      {{-- Form 1 --}}
      <div class="col-md-12">
        <form method="post" action="{{ route('post.update', ['post' => $post->id]) }}" autocomplete="off" class="form-horizontal">
          @csrf
          @method('put')

          {{-- Post Edit --}}
          <div class="card ">
            <div class="card-header card-header-primary">
              <h4 class="card-title">{{ __('Edit Post') }}</h4>
              <p class="card-category">{{ __('Post information') }}</p>
            </div>
            <div class="card-body ">

              {{-- Season Message --}}
              @if (session('status'))
                <div class="row">
                  <div class="col-sm-12">
                    <div class="alert alert-success">
                      <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <i class="material-icons">close</i>
                      </button>
                      <span>{{ session('status') }}</span>
                    </div>
                  </div>
                </div>
              @endif

              {{-- Title edit --}}
              <div class="row">
                <label class="col-sm-2 col-form-label">{{ __('Title') }}</label>
                <div class="col-sm-10">
                  <div class="form-group{{ $errors->has('title') ? ' has-danger' : '' }}">
                    <input class="form-control{{ $errors->has('title') ? ' is-invalid' : '' }}" name="title" id="input-title" type="text" placeholder="{{ __('Title') }}" value="{{ $post->title }}" required="true" aria-required="true"/>
                    @if ($errors->has('title'))
                      <span id="title-error" class="error text-danger" for="input-title">{{ $errors->first('title') }}</span>
                    @endif
                  </div>
                </div>
              </div>

              {{-- Description edit --}}
              <div class="row">
                <label class="col-sm-2 col-form-label">{{ __('Description') }}</label>
                <div class="col-sm-10">
                  <div class="form-group{{ $errors->has('desc') ? ' has-danger' : '' }}">
                    <input class="form-control{{ $errors->has('desc') ? ' is-invalid' : '' }}" name="desc" id="input-desc" type="text" placeholder="{{ __('Description') }}" value="{{ $post->desc }}" required />
                    @if ($errors->has('desc'))
                      <span id="desc-error" class="error text-danger" for="input-desc">{{ $errors->first('desc') }}</span>
                    @endif
                  </div>
                </div>
              </div>
              
            </div>

            {{-- Footer Submit Save Button --}}
            <div class="card-footer ml-auto mr-auto">
              <button type="submit" class="btn btn-primary m-2">{{ __('Save') }}</button>
              <a href="{{ route('post.index') }}" class="btn btn-warning m-2">{{ __('Back') }}</a>
            </div>

          </div>
        </form>
      </div>
      {{-- Form 1 End --}}

    </div>
  </div>
</div>
@endsection

Administrator/resources/views/pages/posts/index.blade.php
@extends('layouts.app', ['activePage' => 'posts', 'titlePage' => __('Posts')])

@section('content')
<div class="content">
  <div class="container-fluid">
    <div class="row">
      <div class="col-md-12">
        {{-- Card --}}
        <div class="card">
          {{-- Card Header --}}
          <div class="card-header card-header-primary">
            <h4 class="card-title ">Posts</h4>
            <p class="card-category">Posts information table</p>
          </div>

          {{-- Card Body --}}
          <div class="card-body">
            <div class="table-responsive text-center" style="overflow-x: hidden;">
              
              @if (session('status'))
                  <div class="row">
                    <div class="col-sm-12">
                      <div class="alert alert-success">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                          <i class="material-icons">close</i>
                        </button>
                        <span>{{ session('status') }}</span>
                      </div>
                    </div>
                  </div>
              @endif

              <livewire:post-table/>

            </div>
          </div>
          {{-- Card Body End--}}

        </div>
        {{-- Card end--}}

      </div>
    </div>
  </div>
</div>

{{-- Include this script if there is delete button for sweet alert --}}
@include('layouts.actions.deleteJS')
@endsection

Administrator/resources/views/pages/posts/show.blade.php
@extends('layouts.app', ['activePage' => 'posts', 'titlePage' => __('Posts')])

@section('content')
<div class="content">
  <div class="container-fluid">
    <div class="row">
      <div class="col-md-12">
        <div class="card">

          {{-- Card Header --}}
          <div class="card-header card-header-primary">
            <h4 class="card-title ">View Post {{ $post->title }}</h4>
            <p class="card-category">Information for post number {{ $post->id }}</p>
          </div>

          {{-- Card Body --}}
          <div class="card-body">
            <div class="table-responsive">

              {{-- Title --}}
              <div class="row mx-0 my-2">
                <p class="col-md-2 col-form-label">{{ __('Title:') }}</p>
                <div class="col-md-10 border-left">
                    <p class="col-form-label">{{ $post->title }}</p>
                </div>
              </div>

              <hr>

              {{-- Description --}}
              <div class="row mx-0 my-2">
                <p class="col-md-2 col-form-label ">{{ __('Description:') }}</p>
                <div class="col-md-10 border-left">
                    <p class="col-form-label">{{ $post->desc }}</p>
                </div>
              </div>

            </div>
          </div>

          <div class="card-footer ml-auto mr-auto">
            <a href="{{ route('post.index') }}" class="btn btn-warning m-2">{{ __('Back') }}</a>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
@endsection